dnl Get myuname
AC_DEFUN(AC_VAR_MYUNAME,
[AC_CACHE_CHECK([system configuration],
  ac_cv_myuname,
[
# Leave a white space between first two '(' for ksh. The sub-shell is needed
# on some machines to avoid the error message when uname is not found; e.g.
# old SUN-OS 3.2 would not execute hostname in (uname -a || hostname). Sigh!
ac_cv_myuname=`( (uname -a) 2>/dev/null || hostname) 2>&1`
# Special mention for Xenix, whose 'uname -a' gives us output like this:
#  sysname=XENIX
#  nodename=whatever
#  release=2.3.2 .. etc...
# Therefore, we strip all this variable assignment junk and remove all the
# new lines to keep the myuname variable sane... --Roland McGrath
ac_cv_myuname=`echo $ac_cv_myuname | sed -e 's/^[^=]*=//' | tr '\012' ' '`
])
AC_DEFINE_UNQUOTED(MYUNAME,"$ac_cv_myuname")dnl
])

dnl AC_KERNEL_VAR(VARIABLE, VAR-TO-CHECK-FOR)
AC_DEFUN(AC_KERNEL_VAR,
[AC_CACHE_VAL(ac_cv_kernel_var_$1,
[if test -n "[$]$1"; then
  ac_cv_prog_$1="[$]$1" # Let the user override the test.
else
   if test ! -f /tmp/kernel.nm; then
      nm $ac_cv_path_kernel > /tmp/kernel.nm
   fi
   if egrep "^$2 " /tmp/kernel.nm >/dev/null 2>&1; then
      ac_cv_kernel_var_$1="$2"
   else
      if egrep " $2\$" /tmp/kernel.nm >/dev/null 2>&1; then
         ac_cv_kernel_var_$1="$2"
      fi
   fi
fi
])dnl
$1="$ac_cv_kernel_var_$1"
dnl AC_SUBST($1)dnl
AC_DEFINE_UNQUOTED($1,"$ac_cv_kernel_var_$1")dnl
])

dnl AC_KERNEL_VARS(VARIABLE, VARS-TO-CHECK-FOR [, VALUE-IF-NOT-FOUND])
dnl example: AC_KERNEL_VARS(KERNEL_TCP_TTL, _tcp_ttl, tcp_ttl)
AC_DEFUN(AC_KERNEL_VARS,
[AC_MSG_CHECKING([for $1])
for ac_var in $2
do
   AC_KERNEL_VAR($1, [$]ac_var)
   test -n "[$]$1" && break
done
ifelse([$3], , , [test -n "[$]$1" || $1="$3"])
if test -n "[$]$1"; then
  AC_MSG_RESULT([$]$1)
else
  AC_MSG_RESULT(no)
fi
])

dnl Check for /dev/dmem or /dev/drum location
AC_DEFUN(AC_SWAP,
[AC_CACHE_CHECK([for location of swap device],
  ac_cv_swap,
[
dnl First determine if test expects a -f or a -c (character device (SYSV))
if test -f /dev/kmem; then
  CTEST="test -f"
elif test -c /dev/kmem; then
  CTEST="test -c"
else
  dnl fall back
  CTEST="test -f"
fi
ac_cv_swap=none
for ac_var in /dev/dmem /dev/drum
do
   if $CTEST $ac_var; then
      ac_cv_swap=$ac_var
      break
   fi
done
])
if test "$ac_cv_swap" != "none"; then
   AC_DEFINE_UNQUOTED(DMEM_LOC,"$ac_cv_swap")dnl
fi
])
