/*
 * snmp_client.h
 */
/***********************************************************
	Copyright 1988, 1989 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
******************************************************************/

#ifndef __SNMPLIB_SNMP_CLIENT_H
#define __SNMPLIB_SNMP_CLIENT_H

struct synch_state {
    int	waiting;
    int status;
/* status codes */
#define STAT_SUCCESS	0
#define STAT_ERROR	1
#define STAT_TIMEOUT 2
    int reqid;
    struct snmp_pdu *pdu;
};

extern struct synch_state snmp_synch_state;

extern struct snmp_pdu *	snmp_pdu_create __P((int command));
extern void	snmp_add_null_var __P((struct snmp_pdu * pdu, oid * name, int name_length));
extern int	snmp_synch_input __P((int op, struct snmp_session * session, int reqid, struct snmp_pdu * pdu, void * magic));
extern struct snmp_pdu *	snmp_fix_pdu __P((struct snmp_pdu * pdu, int command));
extern struct snmp_pdu *	snmp_clone_pdu __P((struct snmp_pdu * pdu));
extern char *	snmp_errstring __P((int errstat));
extern int	snmp_synch_response __P((struct snmp_session * ss, struct snmp_pdu * psu, struct snmp_pdu ** response));
extern void	snmp_synch_setup __P((struct snmp_session * session));
extern char *	snmp_errstring __P((int errstat));
extern int	ms_party_init __P((u_int32 destaddr, oid * src, int * srclen, oid * dst, int * dstlen, oid * context, int * contextlen));

#endif /* __SNMPLIB_SNMP_CLIENT_H */
