dnl AC_TRY_CPPI(INCLUDES, [ACTION-IF-TRUE [, ACTION-IF-FALSE]])
AC_DEFUN(AC_TRY_CPPI,
[AC_REQUIRE_CPP()dnl
cat > conftest.$ac_ext <<EOF
[#]line __oline__ "configure"
#include "confdefs.h"
[$1]
EOF
dnl Capture the stderr of cpp.  eval is necessary to expand ac_cpp.
dnl We used to copy stderr to stdout and capture it in a variable, but
dnl that breaks under sh -x, which writes compile commands starting
dnl with ` +' to stderr in eval and subshells.
eval "$ac_cpp $INCLUDES conftest.$ac_ext >/dev/null 2>conftest.out"
ac_err=`grep -v '^ *+' conftest.out`
if test -z "$ac_err"; then
  ifelse([$2], , :, [rm -rf conftest*
  $2])
else
  echo "$ac_err" >&AC_FD_CC
ifelse([$3], , , [  rm -rf conftest*
  $3
])dnl
fi
rm -f conftest*])

dnl AC_FIND_HEADER(HEADER-FILE, DIRS, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]])
AC_DEFUN(AC_FIND_HEADER,
[dnl Do the transliteration at runtime so arg 1 can be a shell variable.
ac_safe=`echo "$1" | tr './\055' '___'`
AC_MSG_CHECKING([for $1])
AC_CACHE_VAL(ac_cv_header_$ac_safe,
[ac_save_INCLUDES="$INCLUDES"
AC_TRY_CPPI([#include <$1>], eval "ac_cv_header_$ac_safe=yes",
 eval "ac_cv_header_$ac_safe=no")
for ac_dir in $C_INCLUDE_PATH $2
do
 if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = no"; then
   INCLUDES="-I$ac_dir $ac_save_INCLUDES"
   AC_TRY_CPPI([#include <$1>], eval "ac_cv_header_$ac_safe=$ac_dir")
 fi
done

INCLUDES="$ac_save_INCLUDES"
])
if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = no"; then
  AC_MSG_RESULT(no)
  ifelse([$4], , , [$4])
else
  AC_MSG_RESULT(yes)
  ifelse([$3], , :, [$3])
  if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" != yes"; then
     eval "INCLUDES=\"$INCLUDES -I`echo '$ac_cv_header_'$ac_safe`\""
  fi
fi
AC_SUBST(INCLUDES)dnl
])

dnl AC_FIND_XLIB(LIBRARY, FUNCTION, DIRS, [, ACTION-IF-FOUND 
dnl              [, ACTION-IF-NOT-FOUND [, OTHER-LIBRARIES]]])
AC_DEFUN(AC_FIND_XLIB,
[AC_MSG_CHECKING([for -l$1])
changequote(, )dnl
ac_lib_var=`echo $1 | tr '.-/+' '___p'`
changequote([, ])dnl
AC_CACHE_VAL(ac_cv_lib_$ac_lib_var,
[ac_save_LIBS="$LIBS"
LIBS="$LIBS -l$1 $6 $XLIBS"
AC_TRY_LINK(, [$2()], eval "ac_cv_lib_$ac_lib_var=yes",
  eval "ac_cv_lib_$ac_lib_var=no")dnl
for ac_dir in $LD_LIBRARY_PATH $3
do
 if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = no"; then
   LIBS="-L$ac_dir -l$1 $6 $ac_save_LIBS $XLIBS"
   AC_TRY_LINK(, [$2()], eval "ac_cv_lib_$ac_lib_var=$ac_dir")
 fi
done
LIBS="$ac_save_LIBS"
])dnl
if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" != no"; then
  AC_MSG_RESULT(yes)
  ifelse([$4], ,
[changequote(, )dnl
  ac_tr_lib=HAVE_LIB`echo $1 | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
changequote([, ])dnl
  AC_DEFINE_UNQUOTED($ac_tr_lib)
  if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
     XLIBS="-l$1 $XLIBS"
  else
     eval "XLIBS=\"-L`echo '$ac_cv_lib_'$ac_lib_var` -l$1 $XLIBS\""
  fi
], [$4])
else
  AC_MSG_RESULT(no)
ifelse([$5], , , [$5
])dnl
fi
AC_SUBST(XLIBS)dnl
])
